/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#include "architecture.pmh"
#include "GroupExtract.h"
#include "platform/dlCore.cc"

extern "C"
{

FE_DL_EXPORT void ListDependencies(fe::List<fe::String*>& list)
{
	list.append(new fe::String("feSignalDL"));
	list.append(new fe::String("fexDataToolDL"));
}

FE_DL_EXPORT fe::Library* CreateLibrary(fe::sp<fe::Master> spMaster)
{
	fe::assertData(spMaster->typeMaster());

	fe::Library *pLibrary = new fe::Library();
	pLibrary->add<fe::Fork>("ForkI.Fork.fe");
	pLibrary->add<fe::Fork>("HandlerI.Fork.fe");
	pLibrary->add<fe::Annotate>("AnnotateI.Annotate.fe");
	pLibrary->add<fe::Annotate>("HandlerI.Annotate.fe");
	pLibrary->add<fe::Assign>("AssignI.Assign.fe");
	pLibrary->add<fe::Assign>("HandlerI.Assign.fe");
	pLibrary->add<fe::GroupExtract>("HandlerI.GroupExtract.fe");
	pLibrary->add<fe::PaletteMap>("PaletteI.PaletteMap.fe");
	return pLibrary;
}

}
