/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#include "viewer/viewer.h"
#include "window/WindowEvent.h"
#include "architecture/architecture.h"
#include "math/math.h"

using namespace fe;

int main(int argc,char** argv,char **env)
{
	BWORD completed=FALSE;
	UNIT_START();
	try
	{
		sp<Master> spMaster(new Master);
		assertMath(spMaster->typeMaster());
		spMaster->registry()->manage("fexArchitectureDL");
		sp<ApplicationI> spApplication
			= spMaster->registry()->create("ApplicationI.Configured");

		spApplication->setup(argc, argv, env);

		int &run_level = spMaster->catalog<int>("RunLevel");

		int rv;
		UNIT_TEST(spApplication->loop(rv));
		completed=TRUE;
	}
	catch(Exception &e)
	{
		e.log();
	}
	catch(std::exception &e)
	{
		fprintf(stderr,"%s\n", e.what());
	}
	catch(...)
	{
		feLog("uncaught exception\n");
	}
	UNIT_TEST(completed);
	UNIT_TRACK(2);
	UNIT_RETURN();
}

