import sys
import os
import string

forge = sys.modules["forge"]

def setup(module):
	forge.extPath = os.path.join(forge.rootPath,'ext')
	forge.includemap['ext'] = forge.extPath
	module_list = []

	ext_string = os.getenv('FE_EXT')
	if ext_string != None:
		if ext_string != "":
			extensions = string.split(ext_string, ':')
			for extension in extensions:
				module_list.append(extension)
	else:
		for name in os.listdir(forge.extPath):
			dir_path = os.path.join(forge.extPath, name)
			if os.path.isdir(dir_path):
				bld_py_path = os.path.join(dir_path, 'bld.py')
				if os.path.exists(bld_py_path):
					module_list.append(name)
	ext_no_string = os.getenv('FE_NO_EXT')
	if ext_no_string != None:
		no_extensions = string.split(ext_no_string, ':')
		for extension in no_extensions:
			try:
				module_list.remove(extension)
			except:
				pass

	forge.cprint(forge.CYAN,1, 'Extensions: %d' % len(module_list))
	module_list.sort()
	for i in module_list:
		child = module.Module(i)
		if child.ok != None:
			forge.color_on(1, forge.RED)
			sys.stdout.write('(fail:%s)' % (child.ok))
		elif child.hasDLL and not child.hasLib:
			forge.color_on(0, forge.CYAN)
		else:
			forge.color_on(1, forge.BLUE)
		sys.stdout.write('%s ' % (i))
		forge.color_off()
	forge.color_off()
	sys.stdout.write('\n')

	forge.help.append("""\
Free Electron extensions specific help
Environment Variables:
FE_EXT            - build only specific extensions
FE_NO_EXT         - avoid building specific extensions
""")

