/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#ifndef __data_Config_h__
#define __data_Config_h__

#include "ConfigI.h"

namespace fe
{

/**	Convienience base class for specification and use of path accessors.
	*/
class FE_DL_EXPORT Config : virtual public ConfigI
{
	public:
				Config(void);
virtual			~Config(void);
//virtual	void	cfgSet(const String &a_key, const String &a_value);

//virtual const String	cfg(const String &a_key);

//virtual	void			cfgParent(sp<ConfigI> a_parent);
virtual	void			configParent(sp<ConfigI> a_parent);

#if 0
		const String	cfg(const String &a_key,const String &a_default);

		void			cfg(std::vector< std::pair<String,String> > &a_entries);
#endif

#if 0
		template <typename T>
		T		&cfg(const String &a_key, Record &a_record);
#endif

		//template <typename T>
		//T		*pcfg(const String &a_key, Record &a_record);

#if 0
		template <typename T>
		const T	&cfg(const String &a_key, Record &a_record, const T &a_default);

		template <typename T>
		T		&cfg(const String &a_key, Record &a_record, T &a_default);
#endif

		template <typename T>
		T		&cfg(const String &a_key);

//virtual	bool	cfgLookup(const String &a_key, String &a_value);
virtual		bool	configLookup(const String &a_key, Instance &a_instance);
virtual		void	configSet(const String &a_key, Instance &a_instance);

	private:
		//std::map<String, String>		m_dictionary;
		sp<ConfigI>						m_parent;
		std::map<String, Instance>		m_catalog;
};

template <typename T>
T &Config::cfg(const String &a_key)
{
	Instance instance;
	bool preexists = configLookup(a_key, instance);

	if(preexists)
	{
		return instance.cast<T>();
	}

	const sp<TypeMaster> &spTM = registry()->master()->typeMaster();
	Instance &new_instance = m_catalog[a_key];
	new_instance.create<T>(spTM);
	return new_instance.cast<T>();
}

#if 0
template <typename T>
T &Config::cfg(const String &a_key, Record &a_record)
{
	if(!a_record.isValid())
	{
		feX(e_cannotFind,
			name().c_str(),
			"for config %s: invalid record",
			a_key.c_str());
	}
	sp<Attribute> spAttribute;
	String value;
	if(!cfgLookup(a_key, value))
	{
		feX(e_cannotFind,
			name().c_str(),
			"%s: not set",
			a_key.c_str());
	}
	VoidAccessor accessor;
	accessor.setup(value);
	void *vPtr = accessor.access(a_record, spAttribute);
	if(!vPtr)
	{
		feX(e_cannotFind,
			name().c_str(),
			"%s: %s not found in record with layout %s",
			a_key.c_str(),
			value.c_str(),
			a_record.layout()->name().c_str());
	}
	return *(T *)vPtr;
}
#endif

#if 0
template <typename T>
T *Config::pcfg(const String &a_key, Record &a_record)
{
	sp<Attribute> spAttribute;

	String value;
	if(!cfgLookup(a_key, value))
	{
		return NULL;
	}
	VoidAccessor accessor;
	accessor.setup(value);
	void *vPtr = accessor.access(a_record, spAttribute);
	return (T *)vPtr;
}

template <typename T>
const T	&Config::cfg(const String &a_key, Record &a_record, const T &a_default)
{
	T *tptr = pcfg<T>(a_key, a_record);
	if(tptr)
	{
		return *tptr;
	}
	return a_default;
}

template <typename T>
T	&Config::cfg(const String &a_key, Record &a_record, T &a_default)
{
	T *tptr = pcfg<T>(a_key, a_record);
	if(tptr)
	{
		return *tptr;
	}
	return a_default;
}
#endif


} /* namespace */


#endif /* __data_Config_h__ */
