/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#ifndef __shape_Operator_h__
#define __shape_Operator_h__

FE_ATTRIBUTE("op:choice","Record of particular interest during an operation");

namespace fe
{

/**************************************************************************//**
	@brief Operator RecordView

	A step in a pipeline.
*//***************************************************************************/
class FE_DL_EXPORT Operator: virtual public RecordView
{
	public:
		Functor< sp<RecordGroup> >		input;
		Functor< sp<RecordGroup> >		output;
		Functor<Record>					choice;

				Operator(void)		{ setName("Operator"); }
		void	addFunctors(void)
				{
					add(input,		"RecordGroup",		FE_USE("op:input"));
					add(output,		"RecordGroup",		FE_USE("op:output"));
					add(choice,		"record",			FE_USE("op:choice"));
				}
virtual	void	initializeRecord(void)
				{
				}
};

} /* namespace */

#endif /* __shape_Operator_h__ */
