/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#include "math.pmh"

namespace fe
{

SpatialTransform operator*(const SpatialTransform& left,
		const SpatialTransform& right)
{
	// [i][j]=sum of [i][k]*[k][j] for all k

	SpatialTransform matrix;

	set(matrix.column(0),
			left(0,0)*right(0,0)+left(1,0)*right(0,1)+left(2,0)*right(0,2),
			left(0,0)*right(1,0)+left(1,0)*right(1,1)+left(2,0)*right(1,2),
			left(0,0)*right(2,0)+left(1,0)*right(2,1)+left(2,0)*right(2,2));

	set(matrix.column(1),
			left(0,1)*right(0,0)+left(1,1)*right(0,1)+left(2,1)*right(0,2),
			left(0,1)*right(1,0)+left(1,1)*right(1,1)+left(2,1)*right(1,2),
			left(0,1)*right(2,0)+left(1,1)*right(2,1)+left(2,1)*right(2,2));

	set(matrix.column(2),
			left(0,2)*right(0,0)+left(1,2)*right(0,1)+left(2,2)*right(0,2),
			left(0,2)*right(1,0)+left(1,2)*right(1,1)+left(2,2)*right(1,2),
			left(0,2)*right(2,0)+left(1,2)*right(2,1)+left(2,2)*right(2,2));

	set(matrix.column(3),
			left(0,3)*right(0,0)+left(1,3)*right(0,1)+left(2,3)*right(0,2)+
			right(0,3),
			left(0,3)*right(1,0)+left(1,3)*right(1,1)+left(2,3)*right(1,2)+
			right(1,3),
			left(0,3)*right(2,0)+left(1,3)*right(2,1)+left(2,3)*right(2,2)+
			right(2,3));

	return matrix;
}

} // namespace
