/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#ifndef __math_algorithms_h__
#define __math_algorithms_h__

namespace fe
{

FE_DL_PUBLIC
bool intersectRaySphere(	Real *a_collisionDistance,
							const SpatialVector &a_rayRoot,
							const SpatialVector &a_rayDirection,
							const SpatialVector &a_sphereCenter,
							const Real &a_sphereRadius);


FE_DL_PUBLIC
bool intersectLinePlane(	SpatialVector &a_intersection,
							bool a_loBound, bool a_hiBound,
							const SpatialVector &a_lineLo,
							const SpatialVector &a_lineHi,
							const SpatialVector &a_pointOnPlane,
							const SpatialVector &a_planeNormal);


FE_DL_PUBLIC
bool intersectRayPlane(		SpatialVector &a_intersection,
							const SpatialVector &a_lineLo,
							const SpatialVector &a_lineHi,
							const SpatialVector &a_pointOnPlane,
							const SpatialVector &a_planeNormal);


FE_DL_PUBLIC
bool intersectLineTriangle(	SpatialVector &a_intersection,
							bool a_loBound, bool a_hiBound,
							const SpatialVector &a_lineLo,
							const SpatialVector &a_lineHi,
							const SpatialVector &a_triA,
							const SpatialVector &a_triB,
							const SpatialVector &a_triC,
							const SpatialVector &a_triNormal);


FE_DL_PUBLIC
bool intersectRayTriangle(	SpatialVector &a_intersection,
							const SpatialVector &a_lineLo,
							const SpatialVector &a_lineHi,
							const SpatialVector &a_triA,
							const SpatialVector &a_triB,
							const SpatialVector &a_triC);

FE_DL_PUBLIC
bool pointInTriangle(		const SpatialVector &a_point,
							const SpatialVector &a_triA,
							const SpatialVector &a_triB,
							const SpatialVector &a_triC);

FE_DL_PUBLIC
Real randomReal(			const Real &a_min,
							const Real &a_max);


} /* namespace */

#endif /* __math_algorithms_h__ */

