import sys
forge = sys.modules["forge"]

def setup(module):
	srcList =	[	"math.pmh",
					"Matrix3x4",
					"Box",
					"Quaternion",
					"Mass",
					"algorithms",
					"assertMath"
				]

	deplibs = forge.basiclibs

	# just laziness; Win32 could be DLL if you FE_MATH_PORT'd every function
	if forge.fe_os == 'FE_WIN32':
		lib = module.Lib("fexMath",srcList)
		forge.deps( ["fexMathLib"], deplibs )
	elif forge.fe_os == 'FE_OSX':
		lib = module.DLL("fexMath",srcList)
		forge.deps( ["fexMathLib"], deplibs )
	else:
		lib = module.DLL("fexMath",srcList)

	module.Module('test')
