/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#include "math/math.h"

using namespace fe;

int main(void)
{
	UNIT_START();
	BWORD completed=FALSE;

	try
	{
		DAGNode node1;
		DAGNode node2;
		DAGNode node3;
		DAGNode node4;

		node3.attachTo(node1);
		node3.attachTo(node2);
		node4.attachTo(node2);

		UNIT_TEST(node1.parentCount()==0);
		UNIT_TEST(node1.childCount()==1);
		UNIT_TEST(node2.parentCount()==0);
		UNIT_TEST(node2.childCount()==2);
		UNIT_TEST(node3.parentCount()==2);
		UNIT_TEST(node3.childCount()==0);
		UNIT_TEST(node4.parentCount()==1);
		UNIT_TEST(node4.childCount()==0);

		node3.detach();
		node4.detachFrom(node1);
		node4.detachFrom(node2);

		UNIT_TEST(!node1.parentCount());
		UNIT_TEST(!node1.childCount());
		UNIT_TEST(!node2.parentCount());
		UNIT_TEST(!node2.childCount());
		UNIT_TEST(!node3.parentCount());
		UNIT_TEST(!node3.childCount());
		UNIT_TEST(!node4.parentCount());
		UNIT_TEST(!node4.childCount());

		completed=TRUE;
	}
	catch(Exception &e)	{ e.log(); }
	catch(...)			{ feLog("uncaught exception\n"); }

	UNIT_TEST(completed);
	UNIT_TRACK(17);
	UNIT_RETURN();
}
