/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#include "shape.pmh"
#include "platform/dlCore.cc"

using namespace fe;

extern "C"
{

FE_DL_EXPORT void ListDependencies(fe::List<fe::String*>& list)
{
	list.append(new String("feSignalDL"));
}

FE_DL_EXPORT fe::Library* CreateLibrary(sp<Master> spMaster)
{
	fe::assertMath(spMaster->typeMaster());

	String path=spMaster->catalog<String>("String","MediaPath")+
			"/template/shape.rg";

	sp<Scope> spScope=spMaster->catalogComponent("Scope","SimScope");
	RecordView::registerFactory<Sphere>(spScope);
	RecordView::registerFactory<Disk>(spScope);
	RecordView::registerFactory<Cylinder>(spScope);
	RecordView::loadRecordGroup(spScope,path);

	Library *pLibrary = new Library();

//	pLibrary->addSingleton<PickSelector>("SelectorI.PickSelector.fe");

	pLibrary->add<ShapeSelector>("SelectorI.ShapeSelector.fe");

	pLibrary->add<AsParticle>("PopulateI.AsParticle.fe");
	pLibrary->add<AsBounded>("PopulateI.AsBounded.fe");
	pLibrary->add<AsPoint>("PopulateI.AsPoint.fe");

	return pLibrary;
}

}
