/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#ifndef __solve_h__
#define __solve_h__

#include "fe/data.h"
#include "math/math.h"
#include "thread/thread.h"

#ifdef MODULE_solve
#define FE_SOLVE_PORT FE_DL_EXPORT
#else
#define FE_SOLVE_PORT FE_DL_IMPORT
#endif

#include "solve/Spline.h"

#include "solve/MatrixSqrt.h"
#include "solve/MatrixPower.h"

#include "solve/DenseVector.h"
#include "solve/SparseArray.h"
#include "solve/SparseMatrix.h"
#include "solve/SparseMatrix3x3.h"
#include "solve/BlockPCG.h"
#include "solve/BiconjugateGradient.h"
#include "solve/BCGThreaded.h"
#include "solve/ConjugateGradient.h"
#include "solve/solveAS.h"

#endif // __solve_h__

