/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#ifndef __solve_solveAS_h__
#define __solve_solveAS_h__

namespace fe
{

/// clear signal
class AsClear
	: public AccessorSet, public Initialize<AsClear>
{
	public:
		void initialize(void)
		{
			add( dataset,		FE_USE("group"));
			add( is,			FE_USE("sim:clear"));
			add( dfdx,			FE_USE("sim:dfdx"));
			add( dfdv,			FE_USE("sim:dfdv"));
		}
		/// dataset to accumulate force on
		Accessor<sp<RecordGroup> >	dataset;
		Accessor<void>				is;
		Accessor< sp<Component> >	dfdx;
		Accessor< sp<Component> >	dfdv;
};

/// accumulate signal
class AsAccumulate
	: public AccessorSet, public Initialize<AsAccumulate>
{
	public:
		void initialize(void)
		{
			add( dataset,		FE_USE("group"));
			add( is,			FE_USE("sim:accumulate"));
			add( dfdx,			FE_USE("sim:dfdx"));
			add( dfdv,			FE_USE("sim:dfdv"));
		}
		/// dataset to accumulate force on
		Accessor<sp<RecordGroup> >	dataset;
		Accessor<void>				is;
		Accessor< sp<Component> >	dfdx;
		Accessor< sp<Component> >	dfdv;
};

class AsSolverParticle
	: public AccessorSet, public Initialize<AsSolverParticle>
{
	public:
		void initialize(void)
		{
			add( index,			FE_USE("sim:index"));
		}
		Accessor<int>			index;
};

class AsRK2
	: public AccessorSet, public Initialize<AsRK2>
{
	public:
		void initialize(void)
		{
			add( f0,		FE_USE("rk2:forceTemp"));
			add( v0,		FE_USE("rk2:velocityTemp"));
			add( l0,		FE_USE("rk2:locationTemp"));
		}
		Accessor<SpatialVector>		f0;
		Accessor<SpatialVector>		v0;
		Accessor<SpatialVector>		l0;
};


} /* namespace */

#endif /* __solve_solveAS_h__ */

