/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#ifndef __viewer_ObjectViewer_h__
#define __viewer_ObjectViewer_h__

namespace fe
{

/**************************************************************************//**
	@brief Viewer designed to inspect a single object

	@ingroup viewer
*//***************************************************************************/
class FE_DL_EXPORT ObjectViewer:
		public ChainSignaler,
		public Initialize<ObjectViewer>,
		virtual public ViewerI,
		virtual public BindI,
		virtual public HandlerI
{
	public:
						ObjectViewer(void);
virtual					~ObjectViewer(void);
		void			initialize(void);

						//* As ViewerI
virtual	void			bind(sp<WindowI> spWindowI);
virtual Real			frameRate(void) const		{ return m_frameRate; }
virtual	void			bind(sp<DrawI> spDrawI)		{ m_spDrawI=spDrawI; }
virtual	sp<ControllerI>	getControllerI(void) const	{ return m_spControllerI; }
virtual	sp<DrawI>		getDrawI(void) const		{ return m_spDrawI; }

						//* As HandlerI
virtual	void			handle(Record& record);
virtual	void			bind(sp<SignalerI> spSignalerI,sp<Layout> spLayout);

	private:
		sp<Scope>		m_spScope;
		sp<DrawI>		m_spDrawI;
		sp<ControllerI>	m_spControllerI;

		AsViewer		m_asViewer;

		Real			m_frameMS;
		Real			m_frameRate;
		Real			m_frameTotal;
		U32				m_frameCount;
};

} /* namespace */

#endif /* __viewer_ObjectViewer_h__ */
