/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#ifndef __viewer__OrthoViewer_h__
#define __viewer__OrthoViewer_h__

namespace fe
{

/**	Orthographic viewer

	@copydoc OrthoViewer_info
	*/
class FE_DL_EXPORT OrthoViewer : public Initialize<OrthoViewer>,
	public Config,
	virtual public ViewerI,
	virtual public HandlerI,
	virtual public BindI
{
	public:
				OrthoViewer(void);
virtual			~OrthoViewer(void);
		void	initialize(void);

				// AS ViewerI
virtual	void	bind(sp<WindowI> spWindowI);
virtual Real	frameRate(void) const	{ return Real(0); }

				// AS HandlerI
virtual	void	handle(Record& record);
virtual	void	bind(sp<SignalerI> spSignalerI,
						sp<Layout> spLayout);

	private:
		hp<WindowI>				m_spWindowI;
		AsOrtho					m_asOrtho;
		AsSignal				m_asSignal;
		AsWindata				m_asWindata;
		sp<ViewI>				m_view;
};

} /* namespace */

#endif /* __viewer__OrthoViewer_h__ */

