/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#ifndef __viewer_QuickViewer_h__
#define __viewer_QuickViewer_h__

namespace fe
{

/**************************************************************************//**
	@brief Self-configuring ObjectViewer

	@ingroup viewer
*//***************************************************************************/
class FE_DL_EXPORT QuickViewer:
		public ObjectViewer,
		public Initialize<QuickViewer>,
		virtual public QuickViewerI
{
	public:
						QuickViewer(void)									{}
virtual					~QuickViewer(void);
		void			initialize(void);

						//* As ObjectViewer
virtual	void			bind(sp<DrawI> spDrawI);

						//* As QuickViewerI
virtual	sp<WindowI>		getWindowI(void)	{ return m_spWindowI; }
virtual	sp<Scope>		getScope(void)		{ return m_spScope; }
virtual	SpatialVector	interestPoint(void)
						{	return m_spInterestHandler->m_spControllerI
								->interestMatrix().translation(); }
virtual	SpatialVector	auxilliaryPoint(void)
						{	return m_spInterestHandler->m_spControllerI
								->auxillaryMatrix().translation(); }
virtual	void			insertBeatHandler(sp<HandlerI> spHandlerI);
virtual	void			insertEventHandler(sp<HandlerI> spEventHandler);
virtual void			insertDrawHandler(sp<HandlerI> spHandlerI);
virtual	void			run(U32 frames);

	private:

	class InterestHandler: public HandlerI
	{
		public:
						InterestHandler(sp<Scope> spScope,
								sp<DrawI> spDrawI,
								sp<ControllerI> spControllerI)
						{
							m_asViewer.bind(spScope);
							m_spDrawI=spDrawI;
							m_spControllerI=spControllerI;
						}

						//* As HandlerI
	virtual void		handle(Record& render);

			sp<DrawI>			m_spDrawI;
			sp<ControllerI>		m_spControllerI;
			AsViewer			m_asViewer;
	};

		sp<WindowI>				m_spWindowI;
		sp<InterestHandler>		m_spInterestHandler;
		sp<SignalerI>			m_spSignalerI;
		sp<HandlerI>			m_spJoyHandler;
		sp<Scope>				m_spScope;
		sp<Layout>				m_spBeatLayout;
		sp<Layout>				m_spRenderLayout;
		AsViewer				m_asViewer;
};

} /* namespace */

#endif /* __viewer_QuickViewer_h__ */
