/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#ifndef __window_ViewerI_h__
#define __window_ViewerI_h__

namespace fe
{

/**************************************************************************//**
	@brief Simple viewer interface

	@ingroup viewer
*//***************************************************************************/
class FE_DL_EXPORT ViewerI: virtual public Component
{
	public:
virtual void			bind(sp<WindowI> spWindowI)							=0;
virtual Real			frameRate(void) const								=0;

						/// Adopts a DrawI
virtual	void			bind(sp<DrawI> spDrawI)								{}

						/// Returns the current ControllerI
virtual	sp<ControllerI>	getControllerI(void) const
						{	return sp<ControllerI>(NULL); }

						/// Returns the current DrawI
virtual	sp<DrawI>		getDrawI(void) const		{ return sp<DrawI>(NULL); }
};

/**	ViewerI attributes
	*/
class FE_DL_EXPORT AsViewer
	: public AccessorSet, public Initialize<AsViewer>
{
	public:
		void initialize(void)
		{
			add(viewer_layer,		FE_USE("viewer:layer"));
			add(viewer_perspective,	FE_USE("viewer:persp"));
		}
		/// rendering layer
		Accessor<I32>	viewer_layer;
		/// 1 if rendering with perspective
		Accessor<I32>	viewer_perspective;
};

} // namespace

#endif /* __window_ViewerI_h__ */
