/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#include "viewer.pmh"
#include "platform/dlCore.cc"

using namespace fe;

extern "C"
{

FE_DL_EXPORT void ListDependencies(List<String*>& list)
{
	list.append(new String("fexWindowDL"));
	list.append(new String("fexDataToolDL"));
}

FE_DL_EXPORT Library* CreateLibrary(sp<Master> spMaster)
{
	fe::assertData(spMaster->typeMaster());
	fe::assertMath(spMaster->typeMaster());

	Library *pLibrary = new Library();
	pLibrary->add<InspectController>("ControllerI.InspectController.fe");
	pLibrary->add<ObjectViewer>("ViewerI.ObjectViewer.fe");
	pLibrary->add<OrthoViewer>("ViewerI.OrthoViewer.fe");
	pLibrary->add<PerspectiveViewer>("ViewerI.PerspectiveViewer.fe");
	pLibrary->add<DrawSelection>("HandlerI.DrawSelection.fe");
	pLibrary->add<QuickViewer>("QuickViewerI.QuickViewer.fe");
	pLibrary->add<DebugController>("HandlerI.DebugController.fe");
	pLibrary->add<WindowController>("HandlerI.WindowController.fe");
	pLibrary->add<EventMap>("HandlerI.EventMap.fe");
	pLibrary->add<MaskMap>("MaskMapI.MaskMap.fe");
	pLibrary->add<PickPoint>("HandlerI.PickPoint.fe");
	pLibrary->add<ProjectPoint>("HandlerI.ProjectPoint.fe");
	pLibrary->add<IntersectRaySphere>("IntersectRayI.Sphere.fe");
	pLibrary->add<IntersectPointTriangle>("IntersectPointI.Triangle.fe");
	pLibrary->add<IntersectRectPoint>("IntersectRectI.Point.fe");
	pLibrary->add<VideoRecorder>("RecorderI.VideoRecorder.fe");
	return pLibrary;
}

}
