import sys
import os
import string
forge = sys.modules["forge"]


def setup(module):
	forge.labPath = os.path.join(forge.rootPath,'lab')
	forge.includemap['lab'] = forge.labPath
	build_labs = []

	lab_string = os.getenv('FE_LAB')
	if lab_string != None and lab_string != "":
		labs = string.split(lab_string, ':')
		for lab in labs:
			build_labs.append(lab)
			module.Module(lab)

	forge.cprint(forge.CYAN,1, 'Labs: %d' % len(build_labs))
	if lab_string == None:
		forge.cprint(forge.CYAN,0,
			'use FE_LAB environment variable to specify labs to build')
	else:
		forge.color_on(0, forge.CYAN)
		build_labs.sort()
		for i in build_labs:
			sys.stdout.write('%s ' % (i))
		forge.color_off()
		sys.stdout.write('\n')

	forge.help.append("""\
Free Electron lab specific help
Environment Variables:
FE_LAB            - build only specific lab modules
""")

