/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#include "vegetation.pmh"

namespace fe
{

void DrawPlant::handle(Record& record)
{
	if(!m_plantRV.scope().isValid())
	{
		sp<Scope> spScope=record.layout()->scope();
		m_plantRV.bind(spScope);
	}

	m_forestRV.bind(record);
	const F32 deltaT=m_forestRV.deltaT();
	sp<DrawI> spDrawI=m_forestRV.drawI();
	sp<ControllerI> spControllerI=m_forestRV.controllerI();

	sp<RecordGroup> spRG=m_forestRV.plants();
	FEASSERT(spRG.isValid());

	for(RecordGroup::iterator it=spRG->begin();it!=spRG->end();it++)
	{
		sp<RecordArray> spRA= *it;
		if(!m_plantRV.plantModel.check(spRA))
			continue;

		m_plantRV.bind(spRA);
		while(m_plantRV.step())
		{
			sp<SketchI> spSketchI=m_plantRV.plantSketch();
			if(!spSketchI.isValid())
			{
				spSketchI=registry()->create("*.PlantSketch");
				FEASSERT(m_plantRV.plantModel().isValid());
				m_plantRV.plantSketch()=spSketchI;

				spSketchI->bind(m_plantRV.plantModel());
				spSketchI->bind(spControllerI);
			}
			FEASSERT(spSketchI.isValid());
			spSketchI->setPaused(deltaT==0.0f);
			spSketchI->draw(spDrawI);
		}
	}
}

} // namespace


