/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#ifndef __vegetation_Plant_h__
#define __vegetation_Plant_h__

FE_ATTRIBUTE("veg:plantmodel",	"Physical vegetation sp<Component>");
FE_ATTRIBUTE("veg:plantsketch",	"Drawable SketchI in sp<Component>");
FE_ATTRIBUTE("veg:plantname",	"Growth data lookup key");

namespace fe
{

/**************************************************************************//**
	@brief Plant RecordView

	@ingroup vegetation
*//***************************************************************************/
class FE_DL_EXPORT Plant: public RecordView
{
	public:
		Functor< sp<Component> >	plantModel;
		Functor< sp<Component> >	plantSketch;
		Functor<String>				plantName;
		Functor<SpatialVector>		location;

				Plant(void)			{ setName("Plant"); }
virtual	void	addFunctors(void)
				{
					add(plantModel,	"Component",FE_USE("veg:plantmodel"));
					add(plantSketch,"Component",FE_USE("veg:plantsketch"));
					add(plantName,	"string",	FE_USE("veg:plantname"));
					add(location,	"spatial_vector",FE_USE("spc:location"));
				}
virtual	void	initializeRecord(void)
				{
					plantModel.attribute()->setSerialize(FALSE);
					plantSketch.attribute()->setSerialize(FALSE);

					set(location());
				}
};

} /* namespace */

#endif /* __vegetation_Plant_h__ */

