/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#ifndef __vegetation_PlantSketch_h__
#define __vegetation_PlantSketch_h__

namespace fe
{

/**************************************************************************//**
	@brief Plant rendering cache

	@ingroup vegetation
*//***************************************************************************/
class FE_DL_EXPORT PlantSketch: virtual public SketchI,
		public Initialize<PlantSketch>
{
	public:
				PlantSketch(void)											{}
		void	initialize(void);
virtual			~PlantSketch(void);

virtual	void	bind(sp<ControllerI> spControllerI)
				{	m_spControllerI=spControllerI; }
virtual	void	bind(sp<Component> spComponent);
virtual	void	draw(sp<DrawI> spDrawI);

virtual	void	setPaused(BWORD paused)		{ m_paused=paused; }
virtual	BWORD	paused(void) const			{ return m_paused; }

	private:
		sp<ControllerI>			m_spControllerI;
		sp<PlantModelI>			m_spPlantModelI;
		sp<DrawMode>			m_spCylinderDrawMode;
		sp<DrawMode>			m_spLineDrawMode;
		sp<DrawMode>			m_spLeafDrawMode;
		SpatialVector*			m_pOldLines;
		SpatialVector*			m_pShadowLines;
		SpatialVector*			m_pLines;
		SpatialVector*			m_pLineNormals;
		BWORD					m_paused;

		sp<Profiler>			m_spProfiler;
		sp<Profiler::Profile>	m_spProfileStartup;
		sp<Profiler::Profile>	m_spProfileCamera;
		sp<Profiler::Profile>	m_spProfileIterate;
		sp<Profiler::Profile>	m_spProfileSpan;
		sp<Profiler::Profile>	m_spProfileLineNormals;
		sp<Profiler::Profile>	m_spProfileDetails;
		sp<Profiler::Profile>	m_spProfilePoints;
		sp<Profiler::Profile>	m_spProfileCylinders;
		sp<Profiler::Profile>	m_spProfileDrawCylinders;
		sp<Profiler::Profile>	m_spProfileShadows;
		sp<Profiler::Profile>	m_spProfileText;
		sp<Profiler::Profile>	m_spProfileLines;
		sp<Profiler::Profile>	m_spProfileLeaves;
};

} /* namespace */

#endif /* __vegetation_PlantSketch_h__ */

