/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#include "vegetation.pmh"
#include "fe/plugin.h"
#include "platform/dlCore.cc"

using namespace fe;

extern "C"
{

FE_DL_EXPORT void ListDependencies(List<String*>& list)
{
	list.append(new fe::String("feSignalDL"));
}

FE_DL_EXPORT Library* CreateLibrary(sp<Master> spMaster)
{
	//* TODO check for redundancy
	fe::assertMath(spMaster->typeMaster());

	sp<Scope> spScope=spMaster->catalogComponent("Scope","PlantScope");
	RecordView::registerFactory<Plant>(spScope);
	RecordView::registerFactory<TreeSeed>(spScope);
	RecordView::registerFactory<TreeLevel>(spScope);
	RecordView::registerFactory<StickLevel>(spScope);
	RecordView::registerFactory<LeafLevel>(spScope);
	RecordView::loadRecordGroup(spScope,"../media/template/vegetation.rg");

	Library* pLibrary = new Library();

	pLibrary->add<DrawPlant>("HandlerI.DrawPlant.fe");
	pLibrary->add<SimPlant>("HandlerI.SimPlant.fe");
	pLibrary->add<Tree>("PlantModelI.Tree.fe");
	pLibrary->add<PlantSketch>("SketchI.PlantSketch.fe");

	return pLibrary;
}

}
