import sys
import time
import os
forge = sys.modules["forge"]

def setup(module):
	srcList = [ "data.pmh",
				"Accessor",
				"PathAccessor",
				"Layout",
				"Record",
				"RecordArray",
				"RecordCookbook",
				"RecordGroup",
				"Scope",
				"SegmentStore",
				"Stream",
				"Reader",
				"WeakRecord",
				"Scanner",
				"AsciiReader",
				"AsciiWriter",
				"BinaryWriter",
				"BinaryReader",
				"Writer",
				"Attribute" ]

	deplibs = [ "fePlatformLib",
				"feMemoryLib",
				"feCoreLib",
				"fePluginLib" ]

	lib = module.DLL( "feData", srcList )

	if forge.fe_os == 'FE_WIN32':
		deplibs += [ "feImportMemoryLib" ]
		forge.deps( ["feDataLib"], deplibs )
	if forge.fe_os == 'FE_OSX':
		forge.deps( ["feDataLib"], deplibs )

	srcList += ["dataDL"]

	dll = module.DLL( "feDataDL", srcList )

	if forge.fe_os == 'FE_WIN32':
		forge.deps( ["feDataDLLib"], deplibs )
	if forge.fe_os == 'FE_OSX':
		forge.deps( ["feDataDLLib"], deplibs )

	forge.tests += [
		("inspect.exe",		"feDataDL",						None,		None) ]

	module.Module('test')

def auto(module):
	test_file = """
	#include <boost/any.hpp>
	#include <boost/tokenizer.hpp>
    int main(void)
    {
		return(0);
    }
    \n"""

	m = forge.cctest(test_file)
	if m:
		return "abort: boost failure: %s" % (m)

	return None

