/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#include "data/data.pmh"
#include "platform/dlCore.cc"

extern "C"
{

FE_DL_EXPORT fe::Library* CreateLibrary(fe::sp<fe::Master> spMaster)
{
	if(!spMaster->cataloged("MediaPath"))
	{
		spMaster->catalog<fe::String>("String","MediaPath")=
				fe::String("${FE_ROOT}/../media").substituteEnv();
	}

	fe::Library *pLibrary = new fe::Library();
	pLibrary->add<fe::SegmentStore>("StoreI.SegmentStore.fe");
	pLibrary->add<fe::Scope>("Scope.Scope.fe");
	pLibrary->add<fe::data::AsciiFileStream>("FileStreamI.Ascii.fe");
	pLibrary->add<fe::data::BinaryFileStream>("FileStreamI.Binary.fe");

	pLibrary->add<fe::AsSystem>("PopulateI.AsSystem.fe");
	pLibrary->add<fe::AsSequenceSignal>("PopulateI.AsSequenceSignal.fe");
	return pLibrary;
}

}

