/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#ifndef __platform_datatypes_h__
#define __platform_datatypes_h__

// NO NAMESPACE

typedef unsigned int	U32;
typedef unsigned short	U16;
typedef unsigned char	U8;
typedef int				I32;
typedef short			I16;
typedef signed char		I8;
typedef float			F32;
typedef double			F64;

#ifndef NULL
#define NULL	0
#endif

typedef bool			BWORD;
typedef char			CHAR;
typedef size_t			UWORD;

#if FE_OS==FE_WIN32
typedef SSIZE_T			IWORD;
#else
typedef ssize_t			IWORD;
#endif

#ifndef FE_DOUBLE_REAL
#define FE_DOUBLE_REAL	1
#endif

#ifndef FE_BOOST_REGEX
#define FE_BOOST_REGEX	1
#endif

#ifndef FE_TSS
#define FE_TSS	1
#endif

namespace fe
{
#if FE_DOUBLE_REAL
	typedef	double			Real;
#else
	typedef	float			Real;
#endif
}

#endif /* __platform_datatypes_h__ */

