import sys
forge = sys.modules["forge"]

def setup(module):
	deplibs = [	"fePlatformLib",
				"feMemoryLib",
				"feCoreLib",
				"fePluginLib" ]

	tests = [	"xComponentHandle",
				"xHub",
				"xPluginLoader",
				"xPluginThreads" ]

	module.DLL( "xPluginLibrary", ["xPluginLibrary"] )
	module.DLL( "xPluginLibrary2", ["xPluginLibrary2"] )

	if forge.fe_os == 'FE_WIN32':
		deplibs += [ "feImportMemoryLib" ]
		forge.deps( ["xPluginLibraryLib"], deplibs )
		forge.deps( ["xPluginLibrary2Lib"], deplibs )
	if forge.fe_os == 'FE_OSX':
		forge.deps( ["xPluginLibraryLib"], deplibs )
		forge.deps( ["xPluginLibrary2Lib"], deplibs )

	for t in tests:
		module.Exe(t)
		forge.deps([t + "Exe"], deplibs)

	forge.tests += [
		("xComponentHandle.exe",	"",					None,		None),
		("xHub.exe",				"",					None,		None),
		("xPluginLoader.exe",		"",					None,		None),
		("xPluginLoader.exe",		"retain",			None,		None),
		("xPluginThreads.exe",		"7 13",				None,		None),
		("xPluginThreads.exe",		"3 777",			None,		None) ]
