/*	Copyright (C) 2003-2008 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#ifndef __signal_dispatch_h__
#define __signal_dispatch_h__

namespace fe
{

class FE_DL_EXPORT Dispatch : public virtual DispatchI
{
	public:
							Dispatch(void);
virtual						~Dispatch(void);
					/**	Execute the call.  See Signature for matching support.
						*/
virtual	bool				call(	const String &a_name,
									std::vector<Instance> a_argv)			= 0;
					/** Return a the signature supported by call() */
virtual	SignatureMap		&signatures(void);

		template <class T>
		void				dispatch(const String &a_name);

		bool				checkedCall(const String &a_name,
									std::vector<Instance> a_argv);

	protected:
		SignatureMap		m_dispatchSignatures;
};

template<class T>
void Dispatch::dispatch(const String &a_name)
{
	m_dispatchSignatures[a_name].append(
		registry()->master()->typeMaster()->lookupType(TypeInfo(typeid(T))));
}

} /* namespace */

#endif /* __signal_dispatch_h__ */

